----
-- Catalog sql init script for PostgreSQL
----

CREATE SEQUENCE OBJECT_METADATA__ID_SEQ;

CREATE TABLE OBJECT_METADATA (
	_ID			BIGINT					PRIMARY KEY	DEFAULT nextval('OBJECT_METADATA__ID_SEQ'),
	_HISTORY	BOOLEAN					NOT NULL	DEFAULT FALSE,
	ID			CHARACTER VARYING(512)	NOT NULL,
	BRANCH		CHARACTER VARYING(256)	NOT NULL,
	VERSION		CHARACTER VARYING(256)	NOT NULL,
	STATUS		CHARACTER VARYING(32)	NOT NULL,
	TIMESTAMP	TIMESTAMP				NOT NULL,
	ALT_ID		CHARACTER VARYING(512),
	ALT_BRANCH	CHARACTER VARYING(256),
	ALT_VERSION	CHARACTER VARYING(256),

	UNIQUE (ID, BRANCH, VERSION)
);

CREATE UNIQUE INDEX OBJECT_METADATA_ID_CURRENT ON OBJECT_METADATA (ID) WHERE _HISTORY = FALSE;
CREATE INDEX OBJECT_METADATA_PAGING_INDEX ON OBJECT_METADATA (TIMESTAMP,_ID);

CREATE TABLE OBJECT_PARTS (
	_META_ID	BIGINT					NOT NULL	REFERENCES OBJECT_METADATA (_ID),
	TYPE		CHARACTER VARYING(256)	NOT NULL,
	DATA		TEXT					NOT NULL,

	PRIMARY KEY (_META_ID, TYPE)
);

CREATE TABLE METADATA_TAGS (
	TAG			TEXT	NOT NULL,
	_META_ID	BIGINT	NOT NULL	REFERENCES	OBJECT_METADATA (_ID),

	UNIQUE (TAG, _META_ID)
);

CREATE INDEX METADATA_TAGS__META_ID ON METADATA_TAGS (_META_ID);
